<template>
  <div class="register">
    <el-form ref="registerRef" :model="registerForm" :rules="registerRules" class="register-form">
      <h3 class="title">国家账羚羊财务平台</h3>
      <el-form-item prop="phonenumber">
        <el-input v-model="registerForm.phonenumber" type="text" size="large" auto-complete="off" placeholder="手机号">
          <template #prefix>
            <svg-icon icon-class="phone" class="el-input__icon input-icon" />
          </template>
        </el-input>
      </el-form-item>
      <el-form-item prop="username">
        <el-input v-model="registerForm.username" type="text" size="large" auto-complete="off" placeholder="账号">
          <template #prefix>
            <svg-icon icon-class="user" class="el-input__icon input-icon" />
          </template>
        </el-input>
      </el-form-item>
      <el-form-item prop="password">
        <el-input v-model="registerForm.password" type="password" size="large" auto-complete="off" placeholder="请输入密码" @keyup.enter="handleRegister">
          <template #prefix>
            <svg-icon icon-class="password" class="el-input__icon input-icon" />
          </template>
        </el-input>
      </el-form-item>
      <el-form-item prop="confirmPassword">
        <el-input v-model="registerForm.confirmPassword" type="password" size="large" auto-complete="off" placeholder="请确认密码" @keyup.enter="handleRegister">
          <template #prefix>
            <svg-icon icon-class="password" class="el-input__icon input-icon" />
          </template>
        </el-input>
      </el-form-item>
      <el-form-item prop="companyName">
        <el-input v-model="registerForm.companyName" type="text" size="large" auto-complete="off" placeholder="企业名称" @keyup.enter="handleRegister">
          <template #prefix>
            <svg-icon icon-class="build" class="el-input__icon input-icon" />
          </template>
        </el-input>
      </el-form-item>
      <el-form-item prop="creditCode">
        <el-input v-model="registerForm.creditCode" type="text" size="large" auto-complete="off" placeholder="统一社会信用编码" @keyup.enter="handleRegister">
          <template #prefix>
            <svg-icon icon-class="online" class="el-input__icon input-icon" />
          </template>
        </el-input>
      </el-form-item>
      <el-form-item prop="role">
        <el-radio-group v-model="registerForm.role">
          <el-radio label="6" border>发单方</el-radio>
          <el-radio label="7" border>供应商</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item prop="code" v-if="captchaEnabled">
        <el-input size="large" v-model="registerForm.code" auto-complete="off" placeholder="验证码" style="width: 63%" @keyup.enter="handleRegister">
          <template #prefix>
            <svg-icon icon-class="validCode" class="el-input__icon input-icon" />
          </template>
        </el-input>
        <div class="register-code">
          <el-button :disabled="isDisabled" style="margin-left:5px;padding-top: 18px;padding-bottom: 18px;" plain :type="isDisabled?'info':'primary'" @click="sendVerifyCode">{{content}}</el-button>
        </div>
      </el-form-item>
      <el-form-item style="width:100%;">
        <el-button :loading="loading" size="large" type="primary" style="width:100%;" @click.prevent="handleRegister">
          <span v-if="!loading">注 册</span>
          <span v-else>注 册 中...</span>
        </el-button>
        <div style="float: right;">
          <router-link class="link-type" :to="'/login'">使用已有账户登录</router-link>
        </div>
      </el-form-item>
    </el-form>
    <!--  底部  -->
    <div class="el-register-footer">
      <span>Copyright © 2018-2022 ezhizao.cn All Rights Reserved.</span>
    </div>
  </div>
</template>

<script setup>
import { ElMessageBox } from 'element-plus'
import { register } from '@/api/login'
import { ref } from '@vue/reactivity'
import { sendSms } from '@/api/tool/sms'

const router = useRouter()
const { proxy } = getCurrentInstance()
const isDisabled = ref(false)
const count = ref(null)
const timer = ref(null)
const content = ref('获取短信验证码')
const phoneReg = /^((1[0-9][0-9])|(15[^4,\D])|(14[57])|(17[0])|(17[7])|(18[0,0-9]))\d{8}$/

const registerForm = ref({
  username: '',
  password: '',
  phonenumber: '',
  confirmPassword: '',
  companyName: '',
  creditCode: '',
  role: '2',
  code: '',
  uuid: ''
})

const equalToPassword = (rule, value, callback) => {
  if (registerForm.value.password !== value) {
    callback(new Error('两次输入的密码不一致'))
  } else {
    callback()
  }
}
const isCreditCode = async (rule, value, callback) => {
  const reg = /^([0-9A-HJ-NPQRTUWXY]{2}\d{6}[0-9A-HJ-NPQRTUWXY]{10}|[1-9]\d{14})$/
  if (!reg.test(value)) {
    callback(new Error('统一社会信用编码格式不正确!'))
  } else {
    callback()
  }
}

const isPhoneNumber = async (rule, value, callback) => {
  if (!phoneReg.test(value)) {
    callback(new Error('请输入正确的手机号!'))
  } else {
    callback()
  }
}

const registerRules = {
  username: [
    { required: true, trigger: 'blur', message: '请输入您的账号' },
    { min: 2, max: 20, message: '用户账号长度必须介于 2 和 20 之间', trigger: 'blur' }
  ],
  password: [
    { required: true, trigger: 'blur', message: '请输入您的密码' },
    { min: 5, max: 20, message: '用户密码长度必须介于 5 和 20 之间', trigger: 'blur' }
  ],
  confirmPassword: [
    { required: true, trigger: 'blur', message: '请再次输入您的密码' },
    { required: true, validator: equalToPassword, trigger: 'blur' }
  ],
  companyName: [{ required: true, trigger: 'blur', message: '企业名称为必填项' }],
  creditCode: [
    { required: true, trigger: 'blur', message: '统一社会信用编码为必填项' },
    { required: true, validator: isCreditCode, trigger: 'blur' }
  ],
  phonenumber: [
    { required: true, trigger: 'blur', message: '手机号为必填项' },
    { required: true, validator: isPhoneNumber, trigger: 'blur' }
  ],
  code: [{ required: true, trigger: 'change', message: '请输入验证码' }]
}

const codeUrl = ref('')
const loading = ref(false)
const captchaEnabled = ref(true)

function handleRegister() {
  proxy.$refs.registerRef.validate((valid) => {
    if (valid) {
      loading.value = true
      register(registerForm.value)
        .then((res) => {
          const username = registerForm.value.username
          ElMessageBox.alert("<font color='red'>恭喜你，您的账号 " + username + ' 注册成功！</font>', '系统提示', {
            dangerouslyUseHTMLString: true,
            type: 'success'
          })
            .then(() => {
              router.push('/login')
            })
            .catch(() => {})
        })
        .catch(() => {
          loading.value = false
        })
    }
  })
}

function sendVerifyCode() {
  if (phoneReg.test(registerForm.value.phonenumber)) {
    sendSms(registerForm.value).then((res) => {
      if (res.code === 200) {
        const TIME_COUNT = 60
        count.value = 60
        timer.value = window.setInterval(() => {
          if (count.value > 0 && count.value <= TIME_COUNT) {
            // 倒计时时不可点击
            isDisabled.value = true
            // 计时秒数
            count.value--
            // 更新按钮的文字内容
            content.value = count.value + 's后重新获取'
          } else {
            // 倒计时完，可点击
            isDisabled.value = false
            // 更新按钮文字内容
            content.value = '获取短信验证码'
            // 清空定时器!!!
            clearInterval(timer.value)
            timer.value = null
          }
        }, 1000)
      } else {
        proxy.$modal.msgWarning('请勿频繁地获取验证码')
      }
    })
  } else {
    proxy.$modal.msgError('请输入正确的手机号')
  }
}
</script>
<style lang='scss' scoped>
.register {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  background-image: url('../assets/images/login-background.png');
  background-size: cover;
}
.title {
  margin: 0px auto 30px auto;
  text-align: center;
  color: #707070;
}

.register-form {
  border-radius: 6px;
  background: #ffffff;
  width: 400px;
  padding: 25px 25px 5px 25px;
  .el-input {
    height: 40px;
    input {
      height: 40px;
    }
  }
  .input-icon {
    height: 39px;
    width: 14px;
    margin-left: 0px;
  }
}
.register-tip {
  font-size: 13px;
  text-align: center;
  color: #bfbfbf;
}
.register-code {
  width: 33%;
  height: 40px;
  float: right;
  img {
    cursor: pointer;
    vertical-align: middle;
  }
}
.el-register-footer {
  height: 40px;
  line-height: 40px;
  position: fixed;
  bottom: 0;
  width: 100%;
  text-align: center;
  color: #fff;
  font-family: Arial;
  font-size: 12px;
  letter-spacing: 1px;
}
.register-code-img {
  height: 40px;
  padding-left: 12px;
}
</style>
